Index: pplinux/linuxnew/include/linux/i2c-slave.h
diff -u /dev/null pplinux/linuxnew/include/linux/i2c-slave.h:1.1
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/include/linux/i2c-slave.h	Thu Feb  3 11:35:38 2005
@@ -0,0 +1,134 @@
+/* ------------------------------------------------------------------------- */
+/* 									     */
+/* i2c-slave.h - definitions for the i2c bus interface slave mode	     */
+/* 									     */
+/* ------------------------------------------------------------------------- */
+/* Author: Thomas Rendelmann (thre@peppercon.de)                             */
+
+/* 
+   Slave functionality is not well supported by the kernel at the moment.
+   Because I2C slave mode works differently than the master mode (the slave
+   mode is always triggered from outside, namely from the master), it doesn't
+   really fit into the kernel's I2C layer. The layer is used for master
+   tranfsers which are triggered from inside the system, mostly from an
+   application.
+   
+   In slave mode, a master simply sends data to the slave (or wants to read
+   data from it, in this case an address should be sent before anyhow to let
+   the slave know which master the data should be sent to). This normally
+   causes an interrupt in the I2C device driver. Because the driver cannot
+   know what this data is for (because no interaction from the userspace
+   preceded the slave operation), the data could not be handled properly with
+   the I2C framework.
+   
+   This is an approach to solve this problem. Within the I2C slave subsystem,
+   each device driver should register in the slave handler. This allows the
+   subsystem to start also master transfers (which are sometimes needed, a
+   lot of systems require both master and slave operations) and to
+   distinguish between several I2C adapters in the system. On the other side
+   of the system, several logical I2C devices can be found. These devices
+   also register in the slave subsystem. The i2c-slave module then can ask
+   every logical device whether it is responsible for the received I2C slave
+   data (or for the data to be sent). So the data can always be delivered
+   from or to the correct logical device. If there is no device responsible
+   for the data transfer, the incoming data is thrown away and for outgoing
+   data an error on the I2C bus should be signalled (or dummy data
+   transferred).
+*/
+
+#ifndef __I2C_SLAVE_H
+#define __I2C_SLAVE_H
+
+/* Includes ----------------------------------------------------------- */
+
+#include <linux/i2c.h>
+
+/* Constants ---------------------------------------------------------- */
+
+/* device operation modes */
+/* Take care when using the I2C_MODE_MASTER_ADDRESS mode, it results in 2
+   I2C messages. The first one transmits the sender's own I2C address
+   (only 7 bit addresses supported) in one byte, the second one transmits
+   the I2C data. This flag might only be used with devices that support
+   this!
+*/
+#define I2C_MODE_MASTER			0x04	/* device works in master mode */
+#define I2C_MODE_MASTER_ADDRESS		0x02	/* device sends its own address on op. */
+#define I2C_MODE_SLAVE			0x01	/* device works in slave mode */
+
+/* ioctl calls */
+#define I2C_DEVICE_SET_TRANSMITTER_MODE	0x0735	/* set the operation mode of the device */
+#define I2C_DEVICE_SET_RECEIVER_MODE	0x0736	/* set the operation mode of the device */
+/* to change the receiver's slave address, use I2C_SLAVE or I2C_SLAVE_FORCE */
+/* to flush the device's buffer, use I2C_SLAVE_FLUSH_BUFFER */
+
+/* For emulated SMBus operations, the I2C_DEVICE_SMBUS_TRANSFER ioctl
+   is supported. Its use results in 2 I2C messages. SMBus messages consist
+   of 2 things: a command and data. The command is always a byte, the data
+   can be a byte or a word. This is represented by the following structure.
+*/
+struct i2c_device_smbus_operation {
+	char read_write;	/* I2C_SMBUS_READ, I2C_SMBUS_WRITE */
+	int transaction;	/* I2C_SMBUS_BYTE_DATA, I2C_SMBUS_WORD_DATA, ... */
+	__u8 command;
+	union i2c_smbus_data data;
+	int length;		/* only for I2C_SMBUS_BLOCK_DATA */
+};
+#define I2C_DEVICE_SMBUS_COMMAND	0x0737	/* ioctl for smbus commands */
+
+/* Data structures ---------------------------------------------------- */
+
+#ifdef __KERNEL__
+
+/* an i2c adapter */
+struct i2c_slave_adapter {
+	/* the physical adapter */
+	struct i2c_adapter* adapter;
+	
+	/* when the adapter could not deliver its data to the device,
+	   the i2c bus is halted; this function reactivates the i2c bus */
+	int (*reactivate)(struct i2c_adapter* adapter);
+};
+
+/* a logical i2c (slave) device */
+struct i2c_slave_device {
+	/* logical name of the device */
+	char name[32];
+
+	/* the I2C adapter to be used */
+	struct i2c_adapter* adapter;
+	
+	/* is the device responsible for the current transfer */
+	/* returns nonzero if responsible and 0 otherwise */
+	int (*is_responsible)(char*, int);
+	
+	/* read and write functions */
+	/* return the actual number of written/read bytes from/to the
+	   logical I2C device or < 0 on error */
+	int (*slave_write)(char*, int);
+	int (*slave_read)(char*, int);
+};
+
+/* Functions ---------------------------------------------------------- */
+
+/* add/remove a physical I2C adapter to the subsystem */
+int i2c_slave_add_adapter(struct i2c_slave_adapter* adapter);
+int i2c_slave_remove_adapter(struct i2c_slave_adapter* adapter);
+
+/* add/remove a logical I2C device to the subsystem */
+int i2c_slave_add_device(struct i2c_slave_device* dev);
+int i2c_slave_remove_device(struct i2c_slave_device* dev);
+
+/* move the data from the locigal device into the physical driver */
+/* both functions return the number of actual written/read bytes */
+int iic_slave_write(struct i2c_adapter* adapter, char* buf, int len);
+int iic_slave_read(struct i2c_adapter* adapter, char* buf, int len, int command);
+	/* command is the i2c slave command;
+	   if command < 0, no command was transferred */
+
+/* unblock a blocked adapter */
+void unblock_adapter(struct i2c_adapter* adapter);
+
+#endif /* __KERNEL__ */
+
+#endif /* __I2C_SLAVE_H */
Index: pplinux/linuxnew/include/linux/i2c.h
diff -u pplinux/linuxnew/include/linux/i2c.h:1.1.323.1 pplinux/linuxnew/include/linux/i2c.h:1.4
--- pplinux/linuxnew/include/linux/i2c.h:1.1.323.1	Thu Feb  3 10:00:16 2005
+++ pplinux/linuxnew/include/linux/i2c.h	Tue Feb 15 12:24:33 2005
@@ -264,6 +264,9 @@
 #define I2C_CLIENT_ALLOW_USE		0x01	/* Client allows access */
 #define I2C_CLIENT_ALLOW_MULTIPLE_USE 	0x02  	/* Allow multiple access-locks */
 						/* on an i2c_client */
+#define I2C_CLIENT_RECV_SLAVE		0x04	/* Read operations perform slave
+						   reads */
+
 
 /* i2c_client_address_data is the struct for holding default client
  * addresses for a driver and for the parameters supplied on the
@@ -300,6 +303,7 @@
 extern int i2c_del_driver(struct i2c_driver *);
 
 extern int i2c_attach_client(struct i2c_client *);
+extern int i2c_attach_client_force(struct i2c_client *);
 extern int i2c_detach_client(struct i2c_client *);
 
 /* Only call these if you grab a resource that makes unloading the
@@ -341,6 +345,10 @@
 		struct i2c_client_address_data *address_data,
 		i2c_client_found_addr_proc *found_proc);
 
+extern int i2c_probe_force(struct i2c_adapter *adapter, 
+			struct i2c_client_address_data *address_data,
+			i2c_client_found_addr_proc *found_proc);
+
 /* An ioctl like call to set div. parameters of the adapter.
  */
 extern int i2c_control(struct i2c_client *,unsigned int, unsigned long);
@@ -466,6 +474,11 @@
 
 #define I2C_SMBUS	0x0720	/* SMBus-level access */
 
+#define I2C_SLAVE_MODE_ENABLE  0x0730	/* start slave receiving */
+#define I2C_SLAVE_MODE_DISABLE 0x0731	/* stop  slave receiving */
+#define I2C_SLAVE_FLUSH_BUFFER 0x0732	/* flush slave read buf  */
+#define I2C_SLAVE_SET_ADDRESS  0x0733	/* set slave i2c address */
+
 /* ... algo-bit.c recognizes */
 #define I2C_UDELAY	0x0705	/* set delay in microsecs between each	*/
 				/* written byte (except address)	*/
Index: pplinux/linuxnew/include/linux/inetdevice.h
diff -u pplinux/linuxnew/include/linux/inetdevice.h:1.1.323.1 pplinux/linuxnew/include/linux/inetdevice.h:1.2
--- pplinux/linuxnew/include/linux/inetdevice.h:1.1.323.1	Thu Feb  3 10:00:16 2005
+++ pplinux/linuxnew/include/linux/inetdevice.h	Wed Apr  6 11:53:12 2005
@@ -22,6 +22,12 @@
 	int	arp_ignore;
 	int	medium_id;
 	int	force_igmp_version;
+
+	/* rwa: for clustering */
+	int	pp_arp_zero_src_ip;
+	int	pp_arp_proxy_enable;
+	int	pp_arp_proxy_src_ip;
+	
 	void	*sysctl;
 };
 
@@ -74,6 +80,11 @@
 #define IN_DEV_ARP_ANNOUNCE(in_dev)	(max(ipv4_devconf.arp_announce, (in_dev)->cnf.arp_announce))
 #define IN_DEV_ARP_IGNORE(in_dev)	(max(ipv4_devconf.arp_ignore, (in_dev)->cnf.arp_ignore))
 
+/* rwa: for clustering */
+#define IN_DEV_PP_ARP_ZERO_SRC_IP(in_dev)	(ipv4_devconf.pp_arp_zero_src_ip || (in_dev)->cnf.pp_arp_zero_src_ip)
+#define IN_DEV_PP_ARP_PROXY_ENABLE(in_dev)	(ipv4_devconf.pp_arp_proxy_enable || (in_dev)->cnf.pp_arp_proxy_enable)
+#define IN_DEV_PP_ARP_PROXY_SRC_IP(in_dev)	((in_dev)->cnf.pp_arp_proxy_src_ip ? (in_dev)->cnf.pp_arp_proxy_src_ip : ipv4_devconf.pp_arp_proxy_src_ip)
+
 struct in_ifaddr
 {
 	struct in_ifaddr	*ifa_next;
Index: pplinux/linuxnew/include/linux/isdn.h
diff -u pplinux/linuxnew/include/linux/isdn.h:1.1.323.1 pplinux/linuxnew/include/linux/isdn.h:1.2
--- pplinux/linuxnew/include/linux/isdn.h:1.1.323.1	Thu Feb  3 10:00:16 2005
+++ pplinux/linuxnew/include/linux/isdn.h	Thu Feb  3 11:35:38 2005
@@ -56,6 +56,9 @@
 
 #define IIOCNETGPN  _IO('I',34)
 
+#define IIOCLASTCALLER _IO('I',125)
+#define IIOCLASTCALLED _IO('I',126)
+
 #define IIOCDBGVAR  _IO('I',127)
 
 #define IIOCDRVCTL  _IO('I',128)
@@ -631,6 +634,8 @@
 	isdn_v110_stream  *v110[ISDN_MAX_CHANNELS];  /* V.110 private data         */
 	struct semaphore  sem;                       /* serialize list access*/
 	unsigned long     global_features;
+	char last_caller[ISDN_MAX_CHANNELS][ISDN_MSNLEN];
+	char last_called[ISDN_MAX_CHANNELS][ISDN_MSNLEN];
 #ifdef CONFIG_DEVFS_FS
 	devfs_handle_t devfs_handle_isdninfo;
 	devfs_handle_t devfs_handle_isdnctrl;
Index: pplinux/linuxnew/include/linux/sched.h
diff -u pplinux/linuxnew/include/linux/sched.h:1.1.323.1 pplinux/linuxnew/include/linux/sched.h:1.2
--- pplinux/linuxnew/include/linux/sched.h:1.1.323.1	Thu Feb  3 10:00:15 2005
+++ pplinux/linuxnew/include/linux/sched.h	Wed Feb 23 18:03:37 2005
@@ -858,6 +858,40 @@
 	__ret;								\
 })
 
+/* backported from 2.6 ------------------------------------------------- */
+
+#define __wait_event_interruptible_timeout(wq, condition, ret)		\
+do {									\
+	wait_queue_t __wait;						\
+	init_waitqueue_entry(&__wait, current);				\
+									\
+	add_wait_queue(&wq, &__wait);					\
+	for (;;) {							\
+		set_current_state(TASK_INTERRUPTIBLE);			\
+		if (condition)						\
+			break;						\
+		if (!signal_pending(current)) {				\
+			ret = schedule_timeout(ret);			\
+			if (!ret)					\
+				break;					\
+			continue;					\
+		}							\
+		ret = -ERESTARTSYS;					\
+		break;							\
+	}								\
+	current->state = TASK_RUNNING;					\
+	remove_wait_queue(&wq, &__wait);				\
+} while (0)
+
+#define wait_event_interruptible_timeout(wq, condition, timeout)	\
+({									\
+	long __ret = timeout;						\
+	if (!(condition))						\
+		__wait_event_interruptible_timeout(wq, condition, __ret); \
+	__ret;								\
+})
+/* --------------------------------------------------------------------- */
+
 #define REMOVE_LINKS(p) do { \
 	(p)->next_task->prev_task = (p)->prev_task; \
 	(p)->prev_task->next_task = (p)->next_task; \
Index: pplinux/linuxnew/include/linux/sysctl.h
diff -u pplinux/linuxnew/include/linux/sysctl.h:1.1.323.1 pplinux/linuxnew/include/linux/sysctl.h:1.3
--- pplinux/linuxnew/include/linux/sysctl.h:1.1.323.1	Thu Feb  3 10:00:16 2005
+++ pplinux/linuxnew/include/linux/sysctl.h	Wed Apr  6 11:53:12 2005
@@ -84,6 +84,10 @@
 	KERN_NODENAME=7,
 	KERN_DOMAINNAME=8,
 
+	KERN_BOARDTYPE=9,
+	KERN_PRODUCTTYPE=10,
+	KERN_PRODUCTION=11,
+
 	KERN_CAP_BSET=14,	/* int: capability bounding set */
 	KERN_PANIC=15,		/* int: panic timeout */
 	KERN_REALROOTDEV=16,	/* real root device to mount after initrd */
@@ -364,6 +368,10 @@
 	NET_IPV4_CONF_FORCE_IGMP_VERSION=17,
 	NET_IPV4_CONF_ARP_ANNOUNCE=18,
 	NET_IPV4_CONF_ARP_IGNORE=19,
+	/* rwa: for clustering ... */
+	NET_IPV4_CONF_PP_ARP_ZERO_SRC_IP=100,
+	NET_IPV4_CONF_PP_ARP_PROXY_ENABLE=101,
+	NET_IPV4_CONF_PP_ARP_PROXY_SRC_IP=102,
 };
 
 /* /proc/sys/net/ipv4/netfilter */
Index: pplinux/linuxnew/include/linux/mtd/map.h
diff -u pplinux/linuxnew/include/linux/mtd/map.h:1.1.323.1 pplinux/linuxnew/include/linux/mtd/map.h:1.2
--- pplinux/linuxnew/include/linux/mtd/map.h:1.1.323.1	Thu Feb  3 10:00:17 2005
+++ pplinux/linuxnew/include/linux/mtd/map.h	Wed Apr  6 11:53:12 2005
@@ -29,6 +29,9 @@
 struct map_info {
 	char *name;
 	unsigned long size;
+#if defined(PRODUCT_FLASHX4)    
+	int chip_size;
+#endif    
 	int buswidth; /* in octets */
 	__u8 (*read8)(struct map_info *, unsigned long);
 	__u16 (*read16)(struct map_info *, unsigned long);
Index: pplinux/linuxnew/include/linux/mtd/mtd.h
diff -u pplinux/linuxnew/include/linux/mtd/mtd.h:1.1.323.1 pplinux/linuxnew/include/linux/mtd/mtd.h:1.3
--- pplinux/linuxnew/include/linux/mtd/mtd.h:1.1.323.1	Thu Feb  3 10:00:17 2005
+++ pplinux/linuxnew/include/linux/mtd/mtd.h	Wed Apr  6 11:53:12 2005
@@ -95,6 +95,7 @@
 #define MEMGETREGIONINFO	_IOWR('M', 8, struct region_info_user)
 #define	MEMREADDATA             _IOWR('M', 9, struct mtd_oob_buf)
 #define	MEMWRITEDATA            _IOWR('M', 10, struct mtd_oob_buf)
+#define MEMREADSIZE		_IOR('M', 11, int)
 
 #ifndef __KERNEL__
 
@@ -188,12 +189,17 @@
 	 * factory data is read only. 
 	 */
 	int (*read_user_prot_reg) (struct mtd_info *mtd, loff_t from, size_t len, size_t *retlen, u_char *buf);
-
 	int (*read_fact_prot_reg) (struct mtd_info *mtd, loff_t from, size_t len, size_t *retlen, u_char *buf);
-
-	/* This function is not yet implemented */
+    
 	int (*write_user_prot_reg) (struct mtd_info *mtd, loff_t from, size_t len, size_t *retlen, u_char *buf);
 
+        int (*lock_user_prot_reg) (struct mtd_info *mtd);
+        int (*is_user_prot_reg_locked) (struct mtd_info *mtd);
+    
+#if defined(PRODUCT_FLASHX4)   
+	int chip_size;
+#endif    
+	
 	/* iovec-based read/write methods. We need these especially for NAND flash,
 	   with its limited number of write cycles per erase.
 	   NB: The 'count' parameter is the number of _vectors_, each of 
@@ -217,7 +223,7 @@
 	int (*suspend) (struct mtd_info *mtd);
 	void (*resume) (struct mtd_info *mtd);
 
-	void *priv;
+	void *priv;	
 };
 
 
Index: pplinux/linuxnew/include/linux/netfilter_ipv4/ipt_FASTNAT.h
diff -u /dev/null pplinux/linuxnew/include/linux/netfilter_ipv4/ipt_FASTNAT.h:1.2
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/include/linux/netfilter_ipv4/ipt_FASTNAT.h	Wed Apr  6 11:53:12 2005
@@ -0,0 +1,17 @@
+#ifndef _IPT_FASTNAT_H
+#define _IPT_FASTNAT_H
+
+#define	IPT_FASTNAT_SRC_ADDR (1 << 0)
+#define	IPT_FASTNAT_SRC_PORT (1 << 1)
+#define IPT_FASTNAT_DST_ADDR (1 << 2)
+#define IPT_FASTNAT_DST_PORT (1 << 3)
+
+struct ipt_fastnat_info {
+	int type;
+	struct in_addr saddr;
+	struct in_addr daddr;
+	u_short sport;
+	u_short dport;
+};
+
+#endif /*_IPT_FASTNAT_H*/
Index: pplinux/linuxnew/include/linux/netfilter_ipv4/ipt_MARK.h
diff -u pplinux/linuxnew/include/linux/netfilter_ipv4/ipt_MARK.h:1.1.323.1 pplinux/linuxnew/include/linux/netfilter_ipv4/ipt_MARK.h:1.2
--- pplinux/linuxnew/include/linux/netfilter_ipv4/ipt_MARK.h:1.1.323.1	Thu Feb  3 10:00:18 2005
+++ pplinux/linuxnew/include/linux/netfilter_ipv4/ipt_MARK.h	Wed Apr  6 11:53:12 2005
@@ -2,7 +2,8 @@
 #define _IPT_MARK_H_target
 
 struct ipt_mark_target_info {
-	unsigned long mark;
+	/* rwa: added mask */
+	unsigned long mark, mask;
 };
 
 #endif /*_IPT_MARK_H_target*/
Index: pplinux/linuxnew/include/net/ip_vs.h
diff -u pplinux/linuxnew/include/net/ip_vs.h:1.1.323.1 pplinux/linuxnew/include/net/ip_vs.h:1.2
--- pplinux/linuxnew/include/net/ip_vs.h:1.1.323.1	Thu Feb  3 10:00:18 2005
+++ pplinux/linuxnew/include/net/ip_vs.h	Wed Apr  6 11:53:12 2005
@@ -97,6 +97,8 @@
 	int             state;          /* sync daemon state */
 	char            mcast_ifn[IP_VS_IFNAME_MAXLEN];
 					/* multicast interface name */
+	u_int32_t	buildnr;	/* build number */
+	u_int64_t	syncid;		/* sync daemon id */
 
 	/* virtual service options */
 	u_int16_t	protocol;
@@ -213,8 +215,9 @@
 
 /* The argument to IP_VS_SO_GET_DAEMON */
 struct ip_vs_daemon_user {
-	int	state;				/* sync daemon state */
-	char	mcast_ifn[IP_VS_IFNAME_MAXLEN];	/* multicast interface name */
+	int	state;					/* sync daemon state */
+	char	mcast_master_ifn[IP_VS_IFNAME_MAXLEN];	/* mcast master interface name */
+	char	mcast_backup_ifn[IP_VS_IFNAME_MAXLEN];	/* mcast backup interface name */
 };
 
 
@@ -724,9 +727,10 @@
  *      (from ip_vs_sync.c)
  */
 extern volatile int ip_vs_sync_state;
-extern char ip_vs_mcast_ifn[IP_VS_IFNAME_MAXLEN];
-extern int start_sync_thread(int state, char *mcast_ifn);
-extern int stop_sync_thread(void);
+extern char ip_vs_mcast_master_ifn[IP_VS_IFNAME_MAXLEN];
+extern char ip_vs_mcast_backup_ifn[IP_VS_IFNAME_MAXLEN];
+extern int start_sync_thread(int state, char *mcast_ifn, __u32 buildnr, __u64 syncid);
+extern int stop_sync_thread(int state);
 extern void ip_vs_sync_conn(struct ip_vs_conn *cp);
 
 
Index: pplinux/linuxnew/init/version.c
diff -u pplinux/linuxnew/init/version.c:1.1.323.1 pplinux/linuxnew/init/version.c:1.2
--- pplinux/linuxnew/init/version.c:1.1.323.1	Thu Feb  3 10:00:11 2005
+++ pplinux/linuxnew/init/version.c	Thu Feb  3 11:35:39 2005
@@ -15,6 +15,9 @@
 #define version_string(a) version(a)
 
 int version_string(LINUX_VERSION_CODE);
+char sysctl_boardtype[65] = UTS_BOARDTYPE;
+char sysctl_producttype[65] = UTS_PRODUCTTYPE;
+char sysctl_production[2] = UTS_PRODUCTION;
 
 struct new_utsname system_utsname = {
 	UTS_SYSNAME, UTS_NODENAME, UTS_RELEASE, UTS_VERSION,
Index: pplinux/linuxnew/kernel/ksyms.c
diff -u pplinux/linuxnew/kernel/ksyms.c:1.1.323.1 pplinux/linuxnew/kernel/ksyms.c:1.2
--- pplinux/linuxnew/kernel/ksyms.c:1.1.323.1	Thu Feb  3 10:00:29 2005
+++ pplinux/linuxnew/kernel/ksyms.c	Thu Feb  3 11:35:39 2005
@@ -58,6 +58,9 @@
 #ifdef CONFIG_KMOD
 #include <linux/kmod.h>
 #endif
+#ifdef CONFIG_BIGPHYS_AREA
+#include <linux/bigphysarea.h>
+#endif
 
 extern void set_device_ro(kdev_t dev,int flag);
 
@@ -117,6 +120,7 @@
 EXPORT_SYMBOL(vmalloc_to_page);
 EXPORT_SYMBOL(mem_map);
 EXPORT_SYMBOL(remap_page_range);
+EXPORT_SYMBOL(zap_page_range);
 EXPORT_SYMBOL(max_mapnr);
 EXPORT_SYMBOL(high_memory);
 EXPORT_SYMBOL(vmtruncate);
@@ -131,6 +135,12 @@
 EXPORT_SYMBOL(kmap_prot);
 EXPORT_SYMBOL(kmap_pte);
 #endif
+#ifdef CONFIG_BIGPHYS_AREA
+EXPORT_SYMBOL(bigphysarea_alloc);
+EXPORT_SYMBOL(bigphysarea_free);
+EXPORT_SYMBOL(bigphysarea_alloc_pages);
+EXPORT_SYMBOL(bigphysarea_free_pages);
+#endif
 
 /* filesystem internal functions */
 EXPORT_SYMBOL(def_blk_fops);
Index: pplinux/linuxnew/kernel/printk.c
diff -u pplinux/linuxnew/kernel/printk.c:1.1.323.1 pplinux/linuxnew/kernel/printk.c:1.2
--- pplinux/linuxnew/kernel/printk.c:1.1.323.1	Thu Feb  3 10:00:29 2005
+++ pplinux/linuxnew/kernel/printk.c	Thu Feb  3 11:35:39 2005
@@ -29,6 +29,10 @@
 
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_PEPPERCON
+# include "asm/ibm4xx.h"
+#endif
+
 #ifdef CONFIG_BOOTX_TEXT
 #include <asm/btext.h>
 extern int force_printk_to_btext;
@@ -138,6 +142,14 @@
 	idx = simple_strtoul(s, NULL, 10);
 	*s = 0;
 
+#ifdef CONFIG_PEPPERCON
+	{
+		bd_t * bd = (bd_t *)__res;
+
+		if (!bd->bi_debug_mode) strcpy(name, "tty2");
+	}
+#endif
+
 	/*
 	 *	See if this tty is not yet registered, and
 	 *	if we have a slot free.
Index: pplinux/linuxnew/kernel/sysctl.c
diff -u pplinux/linuxnew/kernel/sysctl.c:1.1.323.1 pplinux/linuxnew/kernel/sysctl.c:1.2
--- pplinux/linuxnew/kernel/sysctl.c:1.1.323.1	Thu Feb  3 10:00:29 2005
+++ pplinux/linuxnew/kernel/sysctl.c	Thu Feb  3 11:35:39 2005
@@ -55,6 +55,9 @@
 extern int cad_pid;
 extern int laptop_mode;
 extern int block_dump;
+extern char sysctl_boardtype[65];
+extern char sysctl_producttype[65];
+extern char sysctl_production[2];
 
 /* this is needed for the proc_dointvec_minmax for [fs_]overflow UID and GID */
 static int maxolduid = 65535;
@@ -176,6 +179,12 @@
 	 0644, NULL, &proc_doutsstring, &sysctl_string},
 	{KERN_DOMAINNAME, "domainname", system_utsname.domainname, 64,
 	 0644, NULL, &proc_doutsstring, &sysctl_string},
+	{KERN_BOARDTYPE, "boardtype", &sysctl_boardtype, 64,
+	 0644, NULL, &proc_doutsstring, &sysctl_string},
+	{KERN_PRODUCTTYPE, "producttype", &sysctl_producttype, 64,
+	 0644, NULL, &proc_doutsstring, &sysctl_string},
+	{KERN_PRODUCTION, "production", &sysctl_production, 2,
+	 0644, NULL, &proc_doutsstring, &sysctl_string},
 	{KERN_PANIC, "panic", &panic_timeout, sizeof(int),
 	 0644, NULL, &proc_dointvec},
 	{KERN_CORE_USES_PID, "core_uses_pid", &core_uses_pid, sizeof(int),
Index: pplinux/linuxnew/mm/Makefile
diff -u pplinux/linuxnew/mm/Makefile:1.1.323.1 pplinux/linuxnew/mm/Makefile:1.2
--- pplinux/linuxnew/mm/Makefile:1.1.323.1	Thu Feb  3 10:00:29 2005
+++ pplinux/linuxnew/mm/Makefile	Thu Feb  3 11:35:39 2005
@@ -18,4 +18,6 @@
 
 obj-$(CONFIG_HIGHMEM) += highmem.o
 
+obj-$(CONFIG_BIGPHYS_AREA) += bigphysarea.o
+
 include $(TOPDIR)/Rules.make
Index: pplinux/linuxnew/mm/bigphysarea.c
diff -u /dev/null pplinux/linuxnew/mm/bigphysarea.c:1.1
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/mm/bigphysarea.c	Thu Feb  3 11:35:39 2005
@@ -0,0 +1,347 @@
+/* linux/mm/bigphysarea.c, M. Welsh (mdw@cs.cornell.edu)
+ * Copyright (c) 1996 by Matt Welsh.
+ * Extended by Roger Butenuth (butenuth@uni-paderborn.de), October 1997
+ * Extended for linux-2.1.121 till 2.4.0 (June 2000)
+ *     by Pauline Middelink <middelink@polyware.nl>
+ *
+ * This is a set of routines which allow you to reserve a large (?) 
+ * amount of physical memory at boot-time, which can be allocated/deallocated
+ * by drivers. This memory is intended to be used for devices such as 
+ * video framegrabbers which need a lot of physical RAM (above the amount
+ * allocated by kmalloc). This is by no means efficient or recommended;
+ * to be used only in extreme circumstances.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 2 of the License, or
+ *   (at your option) any later version.
+ * 
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
+
+#include <linux/config.h>
+#include <linux/ptrace.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/pci.h>
+#include <linux/proc_fs.h>
+#include <linux/string.h>
+#include <linux/mm.h>
+#include <linux/bootmem.h>
+#include <linux/errno.h>
+#include <linux/malloc.h>
+#include <linux/bigphysarea.h>
+
+static int get_info(char* buf, char**, off_t, int);
+
+typedef struct range_struct {
+	struct range_struct *next;
+	caddr_t base;			/* base of allocated block */
+	size_t  size;			/* size in bytes */
+} range_t;
+
+/*
+ * 0: nothing initialized
+ * 1: bigphysarea_pages initialized
+ * 2: free list initialized
+ */
+static int	init_level = 0;
+static int	bigphysarea_pages = 0;
+static caddr_t	bigphysarea = 0;
+static range_t	*free_list = NULL;
+static range_t	*used_list = NULL;
+static struct resource mem_resource = { "Bigphysarea", 0, 0, IORESOURCE_MEM|IORESOURCE_BUSY };
+
+static
+int __init bigphysarea_init(void)
+{
+	if (bigphysarea_pages == 0 || bigphysarea == 0)
+		return -EINVAL;
+
+	/* create to /proc entry for it */
+	if (!create_proc_info_entry("bigphysarea",0444,&proc_root,get_info)) {
+		// ohoh, no way to free the allocated memory!
+		// continue without proc support, it not fatal in itself
+//		free_bootmem((unsigned long)bigphysarea>>PAGE_SHIFT,bigphysarea_pages<<PAGE_SHIFT);
+//		bigphysarea = 0;
+//		return -ENOMEM;
+	}
+
+	init_level = 1;
+
+	printk(KERN_INFO "bigphysarea: Allocated %d pages at 0x%p.\n",
+	       bigphysarea_pages, bigphysarea);
+
+	return 0;
+}
+
+__initcall(bigphysarea_init);
+
+/*
+ * call when 'bigphysarea=' is given on the commandline.
+ *
+ * Strangely, bootmem is still active during this call, but
+ * during the processing of the initcalls it isn't anymore!
+ * So we alloc the needed memory here instead of bigphysarea_init().
+ */
+static
+int __init bigphysarea_setup(char *str)
+{
+	int par;
+	if (get_option(&str,&par)) {
+		bigphysarea_pages = par;
+		// Alloc the memory
+		bigphysarea = alloc_bootmem_low_pages(bigphysarea_pages<<PAGE_SHIFT);
+		if (!bigphysarea) {
+			printk(KERN_CRIT "bigphysarea: not enough memory for %d pages\n",bigphysarea_pages);
+			return -ENOMEM;
+		}
+
+		// register the resource for it
+		mem_resource.start = bigphysarea;
+		mem_resource.end = mem_resource.start + (bigphysarea_pages<<PAGE_SHIFT);
+		request_resource(&iomem_resource, &mem_resource);
+	}
+	return 1;
+}
+
+__setup("bigphysarea=", bigphysarea_setup);
+
+/*
+ * When we have pages but don't have a freelist, put all pages in
+ * one free list entry. Return 0 on success, 1 on error.
+ */
+static
+int init2(int priority)
+{
+	if (init_level == 1) {
+		free_list = kmalloc(sizeof(range_t), priority);
+		if (free_list != NULL) {
+			free_list->next = NULL;
+			free_list->base = bigphysarea;
+			free_list->size = bigphysarea_pages * PAGE_SIZE;
+			init_level = 2;
+			return 0;
+		}
+	}
+	return 1;
+}
+
+
+/*
+ * Allocate `count' pages from the big physical area. Pages are aligned to
+ * a multiple of `align'. `priority' has the same meaning in kmalloc, it
+ * is needed for management information.
+ * This function may not be called from an interrupt!
+ */
+caddr_t bigphysarea_alloc_pages(int count, int align, int priority)
+{
+	range_t *range, **range_ptr, *new_range, *align_range;
+	caddr_t aligned_base;
+
+	if (init_level < 2)
+		if (init2(priority))
+			return 0;
+	new_range   = NULL;
+	align_range = NULL;
+
+	if (align == 0)
+		align = PAGE_SIZE;
+	else
+		align = align * PAGE_SIZE;
+	/*
+	 * Search a free block which is large enough, even with alignment.
+	 */
+	range_ptr = &free_list;
+	while (*range_ptr != NULL) {
+		range = *range_ptr;
+		aligned_base =
+		  (caddr_t)((((unsigned long)range->base + align - 1) / align) * align);
+		if (aligned_base + count * PAGE_SIZE <= 
+		    range->base + range->size)
+			break;
+	     range_ptr = &range->next;
+	}
+	if (*range_ptr == NULL)
+		return 0;
+	range = *range_ptr;
+	/*
+	 * When we have to align, the pages needed for alignment can
+	 * be put back to the free pool.
+	 * We check here if we need a second range data structure later
+	 * and allocate it now, so that we don't have to check for a
+	 * failed kmalloc later.
+	 */
+	if (aligned_base - range->base + count * PAGE_SIZE < range->size) {
+		new_range = kmalloc(sizeof(range_t), priority);
+		if (new_range == NULL)
+			return NULL;
+	}
+	if (aligned_base != range->base) {
+		align_range = kmalloc(sizeof(range_t), priority);
+		if (align_range == NULL) {
+			if (new_range != NULL)
+				kfree(new_range);
+			return NULL;
+		}
+		align_range->base = range->base;
+		align_range->size = aligned_base - range->base;
+		range->base = aligned_base;
+		range->size -= align_range->size;
+		align_range->next = range;
+		*range_ptr = align_range;
+		range_ptr = &align_range->next;
+	}
+	if (new_range != NULL) {
+		/*
+		 * Range is larger than needed, create a new list element for
+		 * the used list and shrink the element in the free list.
+		 */
+		new_range->base        = range->base;
+		new_range->size        = count * PAGE_SIZE;
+		range->base = new_range->base + new_range->size;
+		range->size = range->size - new_range->size;
+	} else {
+		/*
+		 * Range fits perfectly, remove it from free list.
+		 */
+		*range_ptr = range->next;
+		new_range = range;
+	}
+	/*
+	 * Insert block into used list
+	 */
+	new_range->next = used_list;
+	used_list = new_range;
+
+	return new_range->base;
+}
+
+/*
+ * Free pages allocated with `bigphysarea_alloc_pages'. `base' must be an
+ * address returned by `bigphysarea_alloc_pages'.
+ * This function my not be called from an interrupt!
+ */
+void bigphysarea_free_pages(caddr_t base)
+{
+	range_t *prev, *next, *range, **range_ptr;
+  
+	/*
+	 * Search the block in the used list.
+	 */
+	for (range_ptr = &used_list;
+	     *range_ptr != NULL;
+	     range_ptr = &(*range_ptr)->next)
+		if ((*range_ptr)->base == base)
+			break;
+	if (*range_ptr == NULL) {
+		printk("bigphysarea_free_pages(0x%08x), not allocated!\n",
+		       (unsigned)base);
+		return;
+	}
+	range = *range_ptr;
+	/*
+	 * Remove range from the used list:
+	 */
+	*range_ptr = (*range_ptr)->next;
+	/*
+	 * The free-list is sorted by address, search insertion point
+	 * and insert block in free list.
+	 */
+	for (range_ptr = &free_list, prev = NULL;
+	     *range_ptr != NULL;
+	     prev = *range_ptr, range_ptr = &(*range_ptr)->next)
+		if ((*range_ptr)->base >= base)
+			break;
+	range->next  = *range_ptr;
+	*range_ptr   = range;
+	/*
+	 * Concatenate free range with neighbors, if possible.
+	 * Try for upper neighbor (next in list) first, then
+	 * for lower neighbor (predecessor in list).
+	 */
+	if (range->next != NULL &&
+	    range->base + range->size == range->next->base) {
+		next = range->next;
+		range->size += range->next->size;
+		range->next = next->next;
+		kfree(next);
+	}
+	if (prev != NULL &&
+	    prev->base + prev->size == range->base) {
+		prev->size += prev->next->size;
+		prev->next = range->next;
+		kfree(range);
+	}
+}
+
+caddr_t bigphysarea_alloc(int size)
+{
+	int pages = (size + PAGE_SIZE - 1) / PAGE_SIZE;
+
+	return bigphysarea_alloc_pages(pages, 1, GFP_KERNEL);
+}
+
+void bigphysarea_free(caddr_t addr, int size)
+{
+	(void)size;
+	bigphysarea_free_pages(addr);
+}
+
+static
+int get_info(char *buf, char **a, off_t b, int c)
+{
+	char    *p = buf;
+	range_t *ptr;
+	int     free_count, free_total, free_max;
+	int     used_count, used_total, used_max;
+
+	if (init_level == 1)
+	  init2(GFP_KERNEL);
+
+	free_count = 0;
+	free_total = 0;
+	free_max   = 0;
+	for (ptr = free_list; ptr != NULL; ptr = ptr->next) {
+		free_count++;
+		free_total += ptr->size;
+		if (ptr->size > free_max)
+			free_max = ptr->size;
+	}
+
+	used_count = 0;
+	used_total = 0;
+	used_max   = 0;
+	for (ptr = used_list; ptr != NULL; ptr = ptr->next) {
+		used_count++;
+		used_total += ptr->size;
+		if (ptr->size > used_max)
+			used_max = ptr->size;
+	}
+
+	if (bigphysarea_pages == 0) {
+		p += sprintf(p, "No big physical area allocated!\n");
+		return  p - buf;
+	}
+	  
+	p += sprintf(p, "Big physical area, size %ld kB\n",
+		     bigphysarea_pages * PAGE_SIZE / 1024);
+	p += sprintf(p, "                       free list:             used list:\n");
+	p += sprintf(p, "number of blocks:      %8d               %8d\n",
+		     free_count, used_count);
+	p += sprintf(p, "size of largest block: %8d kB            %8d kB\n",
+		     free_max / 1024, used_max / 1024);
+	p += sprintf(p, "total:                 %8d kB            %8d kB\n",
+		     free_total / 1024, used_total /1024);
+
+	return  p - buf;
+}
